package com.kingdee.eas.custom.shuiyou.task;



import cn.hutool.core.util.StrUtil;
import cn.hutool.cron.task.Task;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.google.common.collect.Maps;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.RequestStateEnum;
import com.kingdee.eas.custom.shuiyou.RequestTypeEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;

import com.kingdee.eas.custom.shuiyou.uitls.SYUCronTaskUtil;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import org.apache.log4j.Logger;

import java.io.Serializable;
import java.util.Map;
import java.util.Optional;
import java.util.concurrent.CountDownLatch;
import java.util.function.Supplier;

public class TaskInfo extends AbstractTaskInfo implements Serializable, Task
{
    private static Logger logger =Logger.getLogger(TaskInfo.class);
    private StringBuilder msg=new StringBuilder();
    private boolean state=true;
    public static final String calculatingCode="100004";
    private int i=0;
    private Context ctx;
    private CountDownLatch cdl;
    public TaskInfo()
    {
        super();

    }
    protected TaskInfo(String pkField)
    {
        super(pkField);

    }
    public TaskInfo setContext(Context context)
    {
        this.ctx=context;
        return this;
    }

    public TaskInfo setCountDownLatch(CountDownLatch cdl)
    {
        this.cdl=cdl;
        return this;
    }
    /**
     * ǰ״̬
     * true ִ
     * false ִ
     * @return
     */
    public boolean isState() {
        return state;
    }

    public String getMsg() {
        return msg.toString();
    }

    /**
     * ʵ
     */
    @Override
    public void execute() {

        this.i=this.i+1;

        try {

            //ִ

            ISYUtilsFacade syu = SYUtilsFacadeFactory.getLocalInstance(this.ctx);
            Map<String,String> map = Maps.newHashMap();
            map.put("requestId",this.getRequestId());

            Optional<TaskRequestParamInfo> requestParamInfo = Optional.ofNullable(this.getRequestParam());
            String param = requestParamInfo.orElse((new TaskRequestParamInfo())).getParamContent();
            //ƴӲ
            if(StrUtil.isBlank(param)){
                JSONObject jsonObject = JSONUtil.parseObj(param);
                for(Map.Entry<String,Object> st : jsonObject.entrySet()){
                    Optional<Object> op = Optional.ofNullable(st.getValue());
                    map.put(st.getKey(),op.orElse("").toString());
                }
            }
            String getParam = JSONUtil.toJsonStr(map);
            logger.info(""+this.getId().toString()+",ַ"+this.getUrl()+","+getParam+"");
            //Զ̽ӿ
            String string = null;
            if(RequestTypeEnum.GET_VALUE.equals(this.getRequestType().getValue())){
                string = syu.get(this.getUrl(),getParam);
            }else{
                string = syu.post(this.getUrl(),getParam);
            }

            JSONObject jsonObject = JSONUtil.parseObj(string);
            JSONObject head =  jsonObject.getJSONObject("head");
            if(null!=head){
                String state = (String) head.get("state");
                String code = (String) head.get("code");
                if("Y".equalsIgnoreCase(state)){
                    logger.info("ɹ"+(this.i)+","+string);
                    //ɹֹͣ
                    this.stop();
                    Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                    TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                    requestResult.setResultContent(string);
                    requestResult.setTask(this);
                    this.setRequestResult(requestResult);
                    //óɹ
                    this.setRequestState(RequestStateEnum.Successful);
                    this.setState(TaskStateEnum.FINISHED);
                    Map<String,Object> paramOsf = JSONUtil.parseObj(getParam);
                    paramOsf.put("result",string);
                    this.callBackOSF(this,paramOsf);
                } else if(calculatingCode.equals(code)){
                    logger.info(""+(this.i)+","+string);
                    //
                } else {
                    logger.info(""+(this.i)+"ʧ,"+string);
                    //ʧֹͣ
                    this.stop();
                    //÷ֵ
                    Optional<TaskRequestResultInfo> resultInfo = Optional.ofNullable(this.getRequestResult());
                    TaskRequestResultInfo requestResult = resultInfo.orElse(new TaskRequestResultInfo());
                    requestResult.setResultContent(string);
                    requestResult.setTask(this);
                    //ʧ
                    this.setRequestResult(requestResult);
                    this.setRequestState(RequestStateEnum.Successful);
                    this.setState(TaskStateEnum.FAIDED);

//                    Map<String,Object> paramOsf = JSONUtil.parseObj(getParam);
//                    paramOsf.put("result",string);
//                    this.callBackOSF(this,paramOsf);
                }
            }
        }catch (BOSException e){
            e.printStackTrace();
            logger.error(e);
            //ʧ
            this.setRequestState(RequestStateEnum.Failed);
            this.setState(TaskStateEnum.FAIDED);
            this.stop();
        }finally {
            //״̬
            try {
                TaskRequestResultFactory.getLocalInstance(ctx).save(this.getRequestResult());
                TaskFactory.getLocalInstance(ctx).save(this);
            } catch (BOSException e) {
                e.printStackTrace();
            } catch (EASBizException e) {
                e.printStackTrace();
            }
        }
    }

    public void callBackOSF(TaskInfo task,Map<String,Object> param){
        try {
            //صosf
            if(StrUtil.isNotBlank(this.getOsfServiceName())) {
                Object obj = MSFServiceFacadeFactory.getLocalInstance(this.ctx).processService(this.getOsfServiceName(), param);
            }
            //״̬
            TaskFactory.getLocalInstance(this.ctx).save(this);
        } catch (BOSException e){
            //e.printStackTrace();
            logger.error(e);
        } catch (EASBizException e){
            //e.printStackTrace();
            logger.error(e);
        }finally {
            try {
                DbUtil.execute(ctx, "update CT_TK_Task set CFRequestState=? where fid=?",
                        new String[]{task.getRequestState().getValue(),task.getId().toString()});
            }catch (Exception e){
                logger.error(e);
            }
        }
    }

    public boolean stop(){
        this.state=false;
        if(null!=cdl) {
            cdl.countDown();
        }
        return SYUCronTaskUtil.getInstance().delSchedule(this);
    }
}