package com.kingdee.eas.custom.shuiyou.uitls;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.cron.CronUtil;
import com.google.common.collect.Maps;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.custom.shuiyou.task.TaskInfo;
import org.apache.log4j.Logger;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

/**
 * 定时任务
 * description: SYUConfigUtil <br>
 * date: 2024/8/23 15:11 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class SYUCronTaskUtil {


    private static Logger logger =Logger.getLogger(SYUCronTaskUtil.class);
    private Snowflake snowflake = IdUtil.getSnowflake(1, 1);
    private static SYUCronTaskUtil instance = new SYUCronTaskUtil();

    private Map<String,String> propt=null;
    public static SYUCronTaskUtil getInstance() {
        return instance;
    }
    public static String CRONTEXT = "cronText";

    private SYUCronTaskUtil() {
        CronUtil.setMatchSecond(true);
        CronUtil.restart();
    }

    public Snowflake getSnowflake() {
        return snowflake;
    }

    public Map<String,String> getPropt(){
        if(null==this.propt){
            this.propt=SYUConfigUtil.getInstance().getConfig();
        }
        return this.propt;
    }

    /**
     * 添加定时任务
     * @param task
     * @return
     */
    public String addSchedule(TaskInfo task){
        return this.addSchedule(null,task);
    }

    /**
     * 添加定时任务
     * @param task
     * @return
     */
    public String addSchedule(String cron,TaskInfo task){

        if(StrUtil.isBlank(cron)){
            cron=this.getPropt().get(CRONTEXT);
        }
        if(StrUtil.isBlankIfStr(task.getId())){
            task.setId(BOSUuid.create(task.getBOSType()));
        }
       return CronUtil.schedule(task.getId().toString(),cron, task);
    }

    /**
     * 移除定时任务
     * @param id
     * @return
     */
    public boolean delSchedule(String id){
        return CronUtil.remove(id);
    }
    /**
     * 移除定时任务
     * @param task
     * @return
     */
    public boolean delSchedule(TaskInfo task){
        return this.delSchedule(task.getId().toString());
    }



    public static void main(String[] args) {

    }
}
