package com.kingdee.eas.custom.shuiyou.uitls;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.google.common.collect.Maps;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.RequestStateEnum;
import com.kingdee.eas.custom.shuiyou.RequestTypeEnum;
import com.kingdee.eas.custom.shuiyou.interfaceiog.LogInfoFactory;
import com.kingdee.eas.custom.shuiyou.task.*;
import okhttp3.*;
import org.apache.log4j.Logger;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import javax.ejb.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.rmi.RemoteException;
import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;

import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.sql.Timestamp;
import java.util.*;

import com.kingdee.eas.custom.shuiyou.interfaceiog.LogInfoInfo;
import java.lang.String;

public class SYUtilsFacadeControllerBean extends AbstractSYUtilsFacadeControllerBean
{
    @Override
    protected String _backTask(Context ctx, String url, String requestId, String osfServiceName, String backParam,TaskCatalogEnum catalog) throws BOSException {
        super._backTask(ctx, url, requestId, osfServiceName, backParam,catalog);
        TaskInfo taskInfo = new TaskInfo();
        try{
            taskInfo.setId(BOSUuid.create(taskInfo.getBOSType()));
            taskInfo.setUrl(url);
            taskInfo.setRequestId(requestId);
            TaskRequestParamInfo requestParam = new TaskRequestParamInfo();
            requestParam.setTask(taskInfo);
            requestParam.setParamContent(backParam);
            IObjectPK pkp = TaskRequestParamFactory.getLocalInstance(ctx).addnew(requestParam);
            requestParam.setId(BOSUuid.read(pkp.toString()));
            taskInfo.setRequestParam(requestParam);
            taskInfo.setOsfServiceName(osfServiceName);
            taskInfo.setRequestType(RequestTypeEnum.GET);
            taskInfo.setRequestState(RequestStateEnum.NotStarted);
            taskInfo.setState(TaskStateEnum.STANDBY);
            taskInfo.setCatalog(catalog);
            TaskRequestResultInfo resultInfo = new TaskRequestResultInfo();
            resultInfo.setTask(taskInfo);
            IObjectPK pkr = TaskRequestResultFactory.getLocalInstance(ctx).addnew(resultInfo);
            resultInfo.setId(BOSUuid.read(pkr.toString()));
            taskInfo.setRequestResult(resultInfo);
            taskInfo.setName(catalog.getAlias());
            String number = SYUCronTaskUtil.getInstance().getSnowflake().nextIdStr();
            taskInfo.setNumber(number);

            IObjectPK pk = TaskFactory.getLocalInstance(ctx).addnew(taskInfo);

        } catch (Exception e){
            e.printStackTrace();
        }
        return taskInfo.getId().toString();
    }

    @Override
    protected String _post(Context ctx, String url, String param) throws BOSException {
        super._post(ctx, url, param);
        String result = "";
        LogInfoInfo logInfo = new LogInfoInfo();
        try {
            //日志
            logInfo.setEntrance(this.getClass().getName());//入口
            Long timestampLong = System.currentTimeMillis();
            UserInfo userInfo = (UserInfo)ctx.get("UserInfo");
            logInfo.setCreator(userInfo);
            Timestamp timestamp = new Timestamp(timestampLong);
            logInfo.setCreateTime(timestamp);
            logInfo.setLastUpdateTime(timestamp);
            logInfo.setLastUpdateUser(userInfo);
            logInfo.setBizDate(timestamp);

            JSONObject paramMap = JSONUtil.parseObj(param);
            //获取配置文件
            Map<String,String> propt = this._getConfig(ctx);
            if(StrUtil.isBlank(paramMap.getStr("timestamp"))){

                paramMap.set("timestamp",String.valueOf(timestampLong));
            }
            if(StrUtil.isBlank(paramMap.getStr("xReqNonce"))){
                String xReqNonce = UUID.randomUUID().toString().replace("-", "");//调用者生成的 UUID(32位)，结合时间戳timestamp 防重放
                paramMap.set("xReqNonce",xReqNonce);
            }
            param=JSONUtil.toJsonStr(paramMap);
            String signature = this._getSignature(ctx,propt,paramMap);
            Map<String,String> headers = new HashMap<String,String>();
            headers.put("appKey",propt.get("appKey"));
            headers.put("timestamp",paramMap.getStr("timestamp"));
            headers.put("version",propt.get("version"));
            headers.put("xReqNonce",paramMap.getStr("xReqNonce"));
            headers.put("signature",signature);
            OkHttpClient client = new OkHttpClient();
            RequestBody body = RequestBody.create(MediaType.parse("application/json"), param);
            Request sYRequest = new Request.Builder()
                    .url(url)
                    .post(body).headers(Headers.of(headers))
                    .build();
            Response sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                result = sYResponse.body().string();
            }else {
                logInfo.setErrorInfo(sYResponse.message());//错误信息
            }
        }catch (IOException e){
            e.printStackTrace();
            logger.error(e);
            logInfo.setErrorInfo(e.getMessage());//接口地址
        }finally {
            logInfo.setInterfaceAddress(url);//接口地址
            logInfo.setInterfaceName(url);//接口名
            logInfo.setInParameter(param);//入参
            logInfo.setOutParameter(result);//回参
            this._log(ctx,logInfo);
        }
        return result;
    }

    @Override
    protected String _get(Context ctx, String url, String param) throws BOSException {
        super._get(ctx, url, param);
        String result = "";
        LogInfoInfo logInfo = new LogInfoInfo();
        try {
            //日志
            logInfo.setEntrance(this.getClass().getName());//入口
            Long timestampLong = System.currentTimeMillis();
            UserInfo userInfo = (UserInfo)ctx.get("UserInfo");
            logInfo.setCreator(userInfo);
            Timestamp timestamp = new Timestamp(timestampLong);
            logInfo.setCreateTime(timestamp);
            logInfo.setLastUpdateTime(timestamp);
            logInfo.setLastUpdateUser(userInfo);
            logInfo.setBizDate(timestamp);

            JSONObject paramMap = JSONUtil.parseObj(param);
            //获取配置文件
            Map<String,String> propt = this._getConfig(ctx);
            if(StrUtil.isBlank(paramMap.getStr("timestamp"))){

                paramMap.set("timestamp",String.valueOf(timestampLong));
            }
            if(StrUtil.isBlank(paramMap.getStr("xReqNonce"))){
                String xReqNonce = UUID.randomUUID().toString().replace("-", "");//调用者生成的 UUID(32位)，结合时间戳timestamp 防重放
                paramMap.set("xReqNonce",xReqNonce);
            }
            param=JSONUtil.toJsonStr(paramMap);
            String signature = this._getSignature(ctx,propt,paramMap);
            Map<String,String> headers = new HashMap<String,String>();
            headers.put("appKey",propt.get("appKey"));
            headers.put("timestamp",paramMap.getStr("timestamp"));
            headers.put("version",propt.get("version"));
            headers.put("xReqNonce",paramMap.getStr("xReqNonce"));
            headers.put("signature",signature);
            OkHttpClient client = new OkHttpClient();
            HttpUrl.Builder urlBuilder = HttpUrl.parse(url).newBuilder();
            for(Map.Entry<String,Object> entry : paramMap.entrySet() ){
                Optional<Object> op = Optional.ofNullable(entry.getValue());
                urlBuilder.addQueryParameter(entry.getKey(), op.orElse("").toString());
            }
            url = urlBuilder.build().toString();
            Request sYRequest = new Request.Builder()
                    .url(url).headers(Headers.of(headers))
                    .get()
                    .build();
            Response sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                result = sYResponse.body().string();
            }else {
                logInfo.setErrorInfo(sYResponse.message());//错误信息
            }
        }catch (IOException e){
            e.printStackTrace();
            logger.error(e);
            logInfo.setErrorInfo(e.getMessage());//接口地址
        }finally {
            logInfo.setInterfaceAddress(url);//接口地址
            logInfo.setInterfaceName(url);//接口名
            logInfo.setInParameter(param);//入参
            logInfo.setOutParameter(result);//回参
            this._log(ctx,logInfo);
        }
        return result;
    }

    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeControllerBean");


    @Override
    protected String _getSignature(Context ctx, Map propt,Map paramMap) throws BOSException {
        logger.error("====获取签名===进入到了com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils.getSignature=======");
        TreeMap<String, String> treeMap = new TreeMap<>();

        String version = (String) propt.get("version");//版本
        String appKey = (String) propt.get("appKey");//身份标识
        String appSecret = (String) propt.get("appSecret");//秘钥
        logger.error("=============参数列================");
        logger.error("version："+version);
        logger.error("param："+paramMap.toString());
        logger.error("appSecret："+appSecret);
        logger.error("==================================");
        treeMap.put("appKey", appKey);
        treeMap.put("appSecret", appSecret);
        treeMap.put("version", version);
        for(Object obj : paramMap.entrySet()){
           Map.Entry<String, Object> entry = (Map.Entry<String, Object>) obj;
           treeMap.put(entry.getKey(), StrUtil.toString(entry.getValue()));
        }
        StringBuilder mergeStr = new StringBuilder();
        for (Map.Entry<String, String> stringStringEntry : treeMap.entrySet()) {
            mergeStr.append(stringStringEntry.getValue());
        }
        logger.error("将以上key=value对的value进行合并,生成一下字符串mergeStr："+mergeStr.toString());
        String encodedStr = null;
        try {
            encodedStr = URLEncoder.encode(mergeStr.toString(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            // URL 编码失败
            e.printStackTrace();
            throw new RuntimeException("url编码失败");
        }
        logger.error("将生成的mergeStr进行Url编码："+encodedStr);

        // 4.利用HmacSHA256算法对signStr进行哈希运算生成消息摘要,摘要结果以Base64结果形式返回，signStr即为请求参数中的signature字段
        String signatureResult = "";
        try {
            Mac mac = Mac.getInstance("HmacSHA256");
            SecretKeySpec signingKey = new SecretKeySpec(appSecret.getBytes(), "HmacSHA256");
            mac.init(signingKey);
            byte[] signData = mac.doFinal(encodedStr.getBytes());
            byte[] resultBytes = Base64.getEncoder().encode(signData);
            signatureResult = new String(resultBytes, "UTF-8");
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("平台不支持 HmacSHA 摘要方式");
        } catch (InvalidKeyException e) {
            throw new RuntimeException("Speicified access secret is not valid.");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException("转码失败");
        }
        logger.error("用HmacSHA256算法对signStr进行哈希运算生成消息摘要,摘要结果以Base64结果形式返回，signStr即为请求参数中的signature字段"+signatureResult);
        logger.error("==========================退出================================");
        return signatureResult;
    }
    /**
     * 签名
     * @param ctx
     * @param param
     * @return
     * @throws BOSException
     */
    @Override
    protected String _getSignature(Context ctx, String param) throws BOSException {
        super._getSignature(ctx, param);
        JSONObject paramMap = JSONUtil.parseObj(param);
        return this._getSignature(ctx,this._getConfig(ctx),paramMap);
    }

    /**
     * /配置文件更新
     * /server/properties/sy/syConfig.properties
     * @param ctx
     * @param filePath
     * @throws BOSException
     */
    @Override
    protected void _initConfig(Context ctx, String filePath) throws BOSException {
        super._initConfig(ctx, filePath);

        SYUConfigUtil.getInstance().initConfig(filePath);
    }

    @Override
    protected LogInfoInfo _log(Context ctx, LogInfoInfo logInfo) throws BOSException {
        try {
            super._log(ctx, logInfo);
            IObjectPK pk = LogInfoFactory.getLocalInstance(ctx).save(logInfo);
            logInfo.setId(BOSUuid.read(pk.toString()));
        }catch (EASBizException e) {
            e.printStackTrace();
            logger.error(e);
        }
        return logInfo;
    }

    /**
     * 获取配置文件
     * @param ctx
     * @return
     * @throws BOSException
     */
    @Override
    protected Map _getConfig(Context ctx) throws BOSException {
        super._getConfig(ctx);
        Map map = SYUConfigUtil.getInstance().getConfig();
        return map;
    }
}